pkgconfigdir = $(libdir)/pkgconfig
pkgconfig_DATA = qal.pc
EXTRA_DIST = $(pkgconfig_DATA)


if BUILDSYSTEM_OPENWRT
h_sources = ./stream/inc/Stream.h \
            ./stream/inc/StreamCompress.h \
            ./stream/inc/StreamPCM.h \
            ./stream/inc/StreamSoundTrigger.h \
            ./device/inc/Device.h \
            ./device/inc/Speaker.h \
            ./device/inc/Bluetooth.h \
            ./plugins/codecs/bt_plugin_intf.h \
            ./device/inc/Headphone.h \
            ./device/inc/USBAudio.h \
            ./device/inc/DeviceAlsa.h \
            ./device/inc/DeviceGsl.h \
            ./device/inc/DeviceImpl.h \
            ./device/inc/SpeakerMic.h \
            ./device/inc/HeadsetMic.h \
            ./device/inc/Handset.h \
            ./device/inc/HandsetMic.h \
            ./device/inc/HandsetVaMic.h \
            ./session/inc/Session.h \
            ./session/inc/PayloadBuilder.h \
            ./session/inc/SessionGsl.h \
            ./session/inc/SessionAts.h \
            ./session/inc/SessionAlsaUtils.h \
            ./session/inc/SessionAlsaPcm.h \
            ./session/inc/SessionAlsaCompress.h \
            ./session/inc/SessionAlsaVoice.h \
            ./session/inc/SoundTriggerEngine.h \
            ./session/inc/SoundTriggerEngineGsl.h \
            ./session/inc/SoundTriggerEngineCapiCnn.h \
            ./session/inc/SoundTriggerEngineCapiVop.h \
            ./resource_manager/inc/ResourceManager.h \
            ./QalDefs.h \
            ./QalApi.h \
            ./QalAudioRoute.h \
            ./QalCommon.h \
            ./utils/inc/QalRingBuffer.h

AM_CPPFLAGS := -I ./stream/inc
AM_CPPFLAGS += -I ./device/inc
AM_CPPFLAGS += -I ./session/inc
AM_CPPFLAGS += -I ./resource_manager/inc
AM_CPPFLAGS += -I ./utils/inc
AM_CPPFLAGS += -I ./

qal_sources = ./stream/src/Stream.cpp \
              ./stream/src/StreamCompress.cpp \
              ./stream/src/StreamPCM.cpp \
              ./stream/src/StreamSoundTrigger.cpp \
              ./device/src/Device.cpp \
              ./device/src/Speaker.cpp \
              ./device/src/Headphone.cpp \
              ./device/inc/USBAudio.cpp \
              ./device/src/DeviceAlsa.cpp \
              ./device/src/SpeakerMic.cpp \
              ./device/src/Bluetooth.cpp \
              ./device/src/DeviceGsl.cpp \
              ./device/src/HeadsetMic.cpp \
              ./device/src/HandsetMic.cpp \
              ./device/src/HandsetVaMic.cpp \
              ./device/src/Handset.cpp \
              ./session/src/Session.cpp \
              ./session/src/PayloadBuilder.cpp \
              ./session/src/SessionGsl.cpp \
              ./session/src/SessionAts.cpp \
              ./session/src/SessionAlsaUtils.cpp \
              ./session/src/SessionAlsaPcm.cpp \
              ./session/src/SessionAlsaCompress.cpp\
              ./session/src/SessionAlsaVoice.cpp\
              ./session/src/SoundTriggerEngine.cpp \
              ./session/src/SoundTriggerEngineGsl.cpp \
              ./session/src/SoundTriggerEngineCapiCnn.cpp \
              ./session/src/SoundTriggerEngineCapiVop.cpp \
              ./resource_manager/src/ResourceManager.cpp \
              ./Qal.cpp \
              ./utils/src/QalRingBuffer.cpp
else
h_sources = ${top_srcdir}/stream/inc/Stream.h \
            ${top_srcdir}/stream/inc/StreamCompress.h \
            ${top_srcdir}/stream/inc/StreamPCM.h \
            ${top_srcdir}/stream/inc/StreamSoundTrigger.h \
            ${top_srcdir}/device/inc/Device.h \
            ${top_srcdir}/device/inc/Speaker.h \
            ${top_srcdir}/device/inc/Headphone.h \
            ${top_srcdir}/device/inc/Bluetooth.h \
            ${top_srcdir}/plugins/codecs/bt_plugin_intf.h \
            ${top_srcdir}/device/inc/USBAudio.h \
            ${top_srcdir}/device/inc/Device.h \
            ${top_srcdir}/device/inc/DeviceAlsa.h \
            ${top_srcdir}/device/inc/DeviceGsl.h \
            ${top_srcdir}/device/inc/DeviceImpl.h \
            ${top_srcdir}/device/inc/SpeakerMic.h \
            ${top_srcdir}/device/inc/HeadsetMic.h \
            ${top_srcdir}/device/inc/Handset.h \
            ${top_srcdir}/device/inc/HandsetMic.h \
            ${top_srcdir}/device/inc/HandsetVaMic.h \
            ${top_srcdir}/device/inc/DisplayPort.h \
            ${top_srcdir}/session/inc/Session.h \
            ${top_srcdir}/session/inc/PayloadBuilder.h \
            ${top_srcdir}/session/inc/SessionGsl.h \
            ${top_srcdir}/session/inc/SessionAts.h \
            ${top_srcdir}/session/inc/SessionAlsaPcm.h \
            ${top_srcdir}/session/inc/SessionAlsaCompress.h \
            ${top_srcdir}/session/inc/SessionAlsaVoice.h \
            ${top_srcdir}/session/inc/SessionAlsaUtils.h \
            ${top_srcdir}/session/inc/SoundTriggerEngine.h \
            ${top_srcdir}/session/inc/SoundTriggerEngineGsl.h \
            ${top_srcdir}/session/inc/SoundTriggerEngineCapiCnn.h \
            ${top_srcdir}/session/inc/SoundTriggerEngineCapiVop.h \
            ${WORKSPACE}/audio/mm-audio/capiv2_api/capi_v2.h \
            ${WORKSPACE}/audio/mm-audio/capiv2_api/capi_v2_events.h \
            ${WORKSPACE}/audio/mm-audio/capiv2_api/capi_v2_extn.h \
            ${WORKSPACE}/audio/mm-audio/capiv2_api/capi_v2_properties.h \
            ${WORKSPACE}/audio/mm-audio/capiv2_api/capi_v2_types.h \
            ${WORKSPACE}/audio/mm-audio/capiv2_api/ar_defs.h \
            ${top_srcdir}/resource_manager/inc/ResourceManager.h \
            ${top_srcdir}/QalDefs.h \
            ${top_srcdir}/QalApi.h \
            ${top_srcdir}/QalAudioRoute.h \
            ${top_srcdir}/QalCommon.h \
            ${top_srcdir}/utils/inc/QalRingBuffer.h

AM_CPPFLAGS := -I $(top_srcdir)/stream/inc
AM_CPPFLAGS += -I $(top_srcdir)/device/inc
AM_CPPFLAGS += -I $(top_srcdir)/session/inc
AM_CPPFLAGS += -I $(top_srcdir)/resource_manager/inc
AM_CPPFLAGS += -I $(top_srcdir)/utils/inc
AM_CPPFLAGS += -I $(top_srcdir)/
AM_CPPFLAGS += $(SPF_CFLAGS)/
AM_CPPFLAGS += $(ACDBDATA_CFLAGS)
AM_CPPFLAGS += -I $(PKG_CONFIG_SYSROOT_DIR)/usr/include/agm

AM_CPPFLAGS += -I ${WORKSPACE}/audio/mm-audio/capiv2_api/

AM_CPPFLAGS += -D__unused=__attribute__\(\(__unused__\)\) -DLINUX_ENABLED

AM_CPPFLAGS += -DCONFIG_GSL

library_include_HEADERS = $(h_sources)
library_includedir = $(includedir)/qal

qal_sources = ${top_srcdir}/stream/src/Stream.cpp \
              ${top_srcdir}/stream/src/StreamCompress.cpp \
              ${top_srcdir}/stream/src/StreamPCM.cpp \
              ${top_srcdir}/stream/src/StreamSoundTrigger.cpp \
              ${top_srcdir}/device/src/Device.cpp \
              ${top_srcdir}/device/src/Speaker.cpp \
              ${top_srcdir}/device/src/Headphone.cpp \
              ${top_srcdir}/device/src/DeviceAlsa.cpp \
              ${top_srcdir}/device/src/SpeakerMic.cpp \
              ${top_srcdir}/device/src/Bluetooth.cpp \
              ${top_srcdir}/device/src/DeviceGsl.cpp \
              ${top_srcdir}/device/src/HeadsetMic.cpp \
              ${top_srcdir}/device/src/Handset.cpp \
              ${top_srcdir}/device/src/HandsetMic.cpp \
              ${top_srcdir}/device/src/HandsetVaMic.cpp \
              ${top_srcdir}/device/src/DisplayPort.cpp \
              ${top_srcdir}/session/src/Session.cpp \
              ${top_srcdir}/session/src/PayloadBuilder.cpp \
              ${top_srcdir}/session/src/SessionGsl.cpp \
              ${top_srcdir}/session/src/SessionAts.cpp \
              ${top_srcdir}/session/src/SessionAlsaUtils.cpp \
              ${top_srcdir}/session/src/SessionAlsaPcm.cpp \
              ${top_srcdir}/session/src/SessionAlsaCompress.cpp \
              ${top_srcdir}/session/src/SessionAlsaVoice.cpp \
              ${top_srcdir}/session/src/SoundTriggerEngine.cpp \
              ${top_srcdir}/session/src/SoundTriggerEngineGsl.cpp \
              ${top_srcdir}/session/src/SoundTriggerEngineCapiCnn.cpp \
              ${top_srcdir}/session/src/SoundTriggerEngineCapiVop.cpp \
              ${top_srcdir}/resource_manager/src/ResourceManager.cpp \
              ${top_srcdir}/Qal.cpp \
              ${top_srcdir}/utils/src/QalRingBuffer.cpp

endif

AM_CPPFLAGS += -D__unused=__attribute__\(\(__unused__\)\)
AM_CPPFLAGS += -DCONFIG_GSL

library_include_HEADERS = $(h_sources)
library_includedir = $(includedir)/qal

lib_LTLIBRARIES     = libqal.la
libqal_la_SOURCES   = $(qal_sources)
libqal_la_LIBADD    = $(GLIB_LIBS) -ltinyalsa -laudioroute -lar_osal -lexpat -ltinycompress
libqal_la_CPPFLAGS := $(AM_CPPFLAGS)
libqal_la_CPPFLAGS += -std=c++14 -DHAVE_PTHREADS -DHAVE_ANDROID_OS
libqal_la_CPPFLAGS += -DDEBUG_REFS_CALLSTACK_ENABLED=0
libqal_la_CPPFLAGS += -DNDEBUG -ftest-coverage -fprofile-arcs
libqal_la_LDFLAGS   = -shared -avoid-version -lgcov
libqal_la_CPPFLAGS += $(GLIB_CFLAGS) -Dstrlcpy=g_strlcpy -Dstrlcat=g_strlcat -include glib.h
if BUILDSYSTEM_OPENWRT
libqal_la_LIBADD += -lglib-2.0
endif

if COMPILE_COMPRESS
libqal_la_CPPFLAGS += -DSND_COMPRESS_DEC_HDR
endif
